SystemOrganization addCategory: #'ICU-NativeBoost-Core'!

Object subclass: #ICUNativeBoost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 10:27'!
getDefaultTimeZone
	"self getDefaultTimeZone"
	
	| buffer1 buffer2 length |
	
	buffer1 := ByteArray new: 200.
	buffer2 := ICUErrorCodeNB new.
	
	length := self getDefaultTimeZone: buffer1 with: buffer1 size / 2 with: buffer2. 
	
	^TwoByteString fromByteArray: buffer1 charSize: length! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 09:29'!
getDefaultTimeZone: aResultBuffer with: aResultCapacity with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucal_getDefaultTimeZone_48( void* aResultBuffer, int aResultCapacity, ICUErrorCodeNB* anErrorCode ) ) module: self inModule 
	
! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 17:28'!
getEnv:  aName
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ NBFFICallout cdecl: #( String  getenv( String aName) ) module: NativeBoost CLibrary
	
! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 21:43'!
inModule

	^ NativeBoost forCurrentPlatform loadModule: 'libicui18n.dylib'! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 21:36'!
ucModule

	^ NativeBoost forCurrentPlatform loadModule: 'libicuuc.dylib'! !

ICUInterface subclass: #ICUInterfaceNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUInterfaceNB commentStamp: '<historical>' prior: 0!
An ICUInterfaceNB class lists the NativeBoost ICU implementation classes.

ICUInterfaceNB makeCurrent.
ICUInterfaceNB isCurrent

!

!ICUInterfaceNB class methodsFor: 'resources' stamp: 'JanVanDeSandt 3/2/2012 14:05'!
nativeCalendarClass

	^ ICUCalendarNB ! !

!ICUInterfaceNB class methodsFor: 'resources' stamp: 'JanVanDeSandt 3/2/2012 14:05'!
nativeConverterClass

	^ ICUConverterNB ! !

NBExternalObject subclass: #ICUHandleNB
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: 'ICUConstants'
	category: 'ICU-NativeBoost-Core'!

ICUHandleNB subclass: #ICUCalendarNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUCalendarNB class methodsFor: 'functions' stamp: 'JanVanDeSandt 3/2/2012 15:09'!
allTimeZones

	^ (self withStatusDo: [ :status | self primOpenTimeZones: status ]) asByteStringCollection ! !

!ICUCalendarNB class methodsFor: 'functions' stamp: 'JanVanDeSandt 3/2/2012 15:10'!
getDefaultTimeZone
	"self getDefaultTimeZone"
	
	| buffer1 length |
	
	buffer1 := ByteArray new: 100.
	length := self withStatusDo: [ :status | self primGetDefaultTimeZone: buffer1 with: buffer1 size / 2 with: status ].
	
	^TwoByteString fromByteArray: buffer1 charSize: length! !

!ICUCalendarNB class methodsFor: 'instance creation' stamp: 'jvds 2/26/2012 13:38'!
openDefaultWithLocale: localeString timezone: timezoneString

	^ self withStatusDo: [ :status |
		self primOpen: timezoneString asUTF16Bytes
			with: timezoneString size
			with: localeString 
			with: 0
			with: status ]! !

!ICUCalendarNB class methodsFor: 'native calls' stamp: 'jvds 2/24/2012 14:26'!
primGetDefaultTimeZone: aResultBuffer with: aResultCapacity with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucal_getDefaultTimeZone_48( void* aResultBuffer, int aResultCapacity, ICUErrorCodeNB* anErrorCode ) )
	
! !

!ICUCalendarNB class methodsFor: 'native calls' stamp: 'jvds 2/26/2012 13:33'!
primOpen: aZoneID with: aZoneIDLength with: aLocale with: aCalendarType with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( ICUCalendarNB ucal_open_48( void* aZoneID, int aZoneIDLength, char* aLocale, int aCalendarType, ICUErrorCodeNB* anErrorCode ) )! !

!ICUCalendarNB class methodsFor: 'native calls' stamp: 'jvds 2/24/2012 16:54'!
primOpenTimeZones: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( ICUEnumerationNB ucal_openTimeZones_48( ICUErrorCodeNB* anErrorCode ) )! !

!ICUCalendarNB methodsFor: 'functions' stamp: 'JanVanDeSandt 3/2/2012 15:13'!
close

	self primClose ! !

!ICUCalendarNB methodsFor: 'functions' stamp: 'JanVanDeSandt 3/2/2012 15:12'!
get: aFieldCode

	^ self withStatusDo: [ :status | self primGet: aFieldCode with: status ]! !

!ICUCalendarNB methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/2/2012 15:16'!
primClose
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( long ucal_close_48( ICUCalendarNB self ) )! !

!ICUCalendarNB methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/2/2012 15:16'!
primGet: aFieldCode with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( long ucal_get_48( ICUCalendarNB self, long aFieldCode, ICUErrorCodeNB* anErrorCode ) )! !

ICUHandleNB subclass: #ICUConverterNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 13:46'!
allNames

	^ (self withStatusDo: [ :status | self primOpenAllNames: status ]) asByteStringCollection! !

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 13:47'!
open: aConverterName

	^ self withStatusDo: [ :status | self primOpen: aConverterName with: status ].
	
	"self open: 'UTF-8'"! !

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 13:46'!
primOpen: aConverterName with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( ICUConverterNB ucnv_open_48( char* aConverterName, ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 13:46'!
primOpenAllNames: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( ICUEnumerationNB ucnv_openAllNames_48( ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:03'!
byteStringFromUChars: aString

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := ByteString new: 100.
		length := self primFromUChars: buffer with: buffer size with: aString asUTF16Bytes with: aString size with: status.
		buffer copyFrom: 1 to: length ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 15:23'!
close

	self primClose ! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 21:40'!
fromAlgorithmic: aSourceType source: aSource destination: aBuffer

	^ self withStatusDo: [ :status |
		self primFromAlgoritmic: aSourceType with: aBuffer with: aBuffer byteSize with: aSource with: aSource byteSize with: status ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 15:19'!
fromAlgorithmic: aSourceType with: aSource

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := ByteArray new: (aSource size * 2) + 8.
		length := self primFromAlgoritmic: aSourceType with: buffer with: buffer size with: aSource with: aSource size with: status.
		length = buffer size
			ifTrue: [ buffer ]
			ifFalse: [ buffer copyFrom: 1 to: length ] ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:01'!
fromUChars: aString

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := String new: 100.
		length := self primFromUChars: buffer with: buffer size with: aString asUTF16Bytes with: aString size with: status.
		buffer copyFrom: 1 to: length ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 3/2/2012 16:58'!
fromUChars: aString destination: aBuffer

	^ self withStatusDo: [ :status |
		self primFromUChars: aBuffer with: aBuffer byteSize with: aString asUTF16Bytes with: aString size with: status ]! !

!ICUConverterNB methodsFor: 'testing' stamp: 'jvds 2/24/2012 15:36'!
isAmbiguous

	^ self primIsAmbiguous ! !

!ICUConverterNB methodsFor: 'testing' stamp: 'jvds 2/24/2012 15:36'!
isFixedWidth

	^ self withStatusDo: [ :status | self primIsFixedWidth: status ]! !

!ICUConverterNB methodsFor: 'accessing' stamp: 'jvds 2/24/2012 16:26'!
maxCharSize

	^ self primMaxCharSize ! !

!ICUConverterNB methodsFor: 'accessing' stamp: 'jvds 2/24/2012 16:26'!
minCharSize

	^ self primMinCharSize ! !

!ICUConverterNB methodsFor: 'accessing' stamp: 'jvds 2/24/2012 15:32'!
name

	^ self withStatusDo: [ :status | (self primGetName: status) readString ]! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/26/2012 13:54'!
primClose
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void ucnv_close_48( self ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/26/2012 14:39'!
primFromAlgoritmic: anAlgoritmicType with: aDestination with: aDestinationCapacity with: aSource with: aSourceLength with: anErrorCode
	"Convert the Unicode string into a codepage string using an existing UConverter. "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucnv_fromAlgorithmic_48( self, int anAlgoritmicType, void* aDestination, int aDestinationCapacity, void* aSource, int aSourceLength, ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/26/2012 13:55'!
primFromUChars: aDestination with: aDestinationCapacity with: aSource with: aSourceLength with: anErrorCode
	"Convert the Unicode string into a codepage string using an existing UConverter. "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucnv_fromUChars_48( self, char* aDestination, int aDestinationCapacity, void* aSource, int aSourceLength, ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/26/2012 13:55'!
primGetName: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* ucnv_getName_48( self, ICUErrorCodeNB anErrorCode ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/26/2012 15:27'!
primGetType
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucnv_getType_48( self ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/26/2012 13:55'!
primIsAmbiguous
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( bool ucnv_isAmbiguous_48( self ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/26/2012 13:55'!
primIsFixedWidth: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( bool ucnv_isFixedWidth_48( self, ICUErrorCodeNB anErrorCode ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/26/2012 13:55'!
primMaxCharSize
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( byte ucnv_getMaxCharSize_48( self ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/26/2012 13:56'!
primMinCharSize
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( byte ucnv_getMinCharSize_48( self ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/26/2012 14:28'!
primToAlgoritmic: anAlgoritmicType with: aDestination with: aDestinationCapacity with: aSource with: aSourceLength with: anErrorCode
	"Convert the Unicode string into a codepage string using an existing UConverter. "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucnv_toAlgorithmic_48( int anAlgoritmicType, self, void* aDestination, int aDestinationCapacity, void* aSource, int aSourceLength, ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/26/2012 13:56'!
primToUChars: aDestination with: aDestinationCapacity with: aSource with: aSourceLength with: anErrorCode
	"Convert the Unicode string into a codepage string using an existing UConverter. "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucnv_toUChars_48( self, void* aDestination, int aDestinationCapacity, void* aSource, int aSourceLength, ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 14:41'!
toAlgorithmic: aTargetType with: aSource

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := ByteArray new: (aSource size * 2) + 8.
		length := self primToAlgoritmic: aTargetType with: buffer with: buffer size with: aSource with: aSource size with: status.
		length = buffer size
			ifTrue: [ buffer ]
			ifFalse: [ buffer copyFrom: 1 to: length ] ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 15:37'!
toUChars: aString

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := ByteArray new: (aString size * 2) + 8.
		length := self primToUChars: buffer with: buffer size / 2 with: aString with: aString byteSize with: status.
		TwoByteString fromByteArray: buffer charSize: length ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 3/2/2012 17:07'!
toUChars: aString destination: aBuffer

	^ self withStatusDo: [ :status |
		self primToUChars: aBuffer with: (aBuffer byteSize / 2) floor with: aString with: aString byteSize with: status ]! !

!ICUConverterNB methodsFor: 'accessing' stamp: 'jvds 2/26/2012 15:28'!
type

	^ self primGetType! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:09'!
wideStringFromUChars: aString

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := ByteArray new: 100.
		length := self primFromUChars: buffer with: buffer size with: aString asUTF16Bytes with: aString size * 4 with: status.
		buffer copyFrom: 1 to: length ]! !

ICUHandleNB subclass: #ICUEnumerationNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:43'!
byteStringCollection: anEnumAddress

	^ Array streamContents: [ :stream |
		| status result |
		status := ICUErrorCodeNB new.
		[ result := self primNext: anEnumAddress with: status. status check. result isNil ]
			whileFalse: [ stream nextPut: result readString ].
		self primClose: anEnumAddress ]! !

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:39'!
nbLibraryNameOrHandle

	^'libicui18n.dylib'! !

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:42'!
primClose: aHandle
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void uenum_close_48( void* aHandle) )! !

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:38'!
primNext: aHandle with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uenum_next_48(void* aHandle, nil, ICUErrorCodeNB* anErrorCode ) )! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:56'!
asByteStringCollection
	"Get all elements of this enumeration as single byte Strings and close this enumeration."

	^ Array streamContents: [ :stream |
		| status result |
		status := ICUErrorCodeNB new.
		[ result := self primNext: status. status check. result isNil ]
			whileFalse: [ stream nextPut: result readString ].
		self primClose ]! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/13/2012 21:53'!
close

	self primClose ! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 13:53'!
next

	^ (self withStatusDo: [ :status | self primNext: status ]) readString! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:49'!
primClose
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void uenum_close_48( self ) )! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:49'!
primNext: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uenum_next_48( self, nil, ICUErrorCodeNB* anErrorCode ) )! !

!ICUHandleNB class methodsFor: 'utility' stamp: 'jvds 2/26/2012 13:50'!
collectionFromArrayOfCharPointers: arrayOfPointers
	"Answer a collection of Strings created from <arrayOfPointers>."

	^ Array streamContents: [ :stream |
		| index address |
		index := 0.
		[ address := NBExternalAddress value: (arrayOfPointers ulongAt: index). address isNull ] 
			whileFalse: [
				stream nextPut: address readString.
				index := index + 4 ] ]! !

!ICUHandleNB class methodsFor: 'resources' stamp: 'jvds 2/24/2012 13:59'!
nbLibraryNameOrHandle

	^'libicui18n.dylib'! !

!ICUHandleNB class methodsFor: 'utility' stamp: 'jvds 2/26/2012 13:37'!
withStatusDo: aOneArgBlock

	| status result |
	
	status := ICUErrorCodeNB new.
	result := aOneArgBlock value: status.
	status check.
	^ result! !

!ICUHandleNB methodsFor: 'resources' stamp: 'jvds 2/24/2012 15:24'!
nbLibraryNameOrHandle

	^self class nbLibraryNameOrHandle ! !

!ICUHandleNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 13:37'!
withStatusDo: aOneArgBlock

	^ self class withStatusDo: aOneArgBlock! !

ICUHandleNB subclass: #ICULocaleNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 12:44'!
isoCountries

	| arrayOfPointers|

	arrayOfPointers := self primGetISOCountries.
	^ self collectionFromArrayOfCharPointers: arrayOfPointers! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:00'!
isoLanguages

	| arrayOfPointers|

	arrayOfPointers := self primGetISOLanguages.
	^ self collectionFromArrayOfCharPointers: arrayOfPointers! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 12:27'!
primGetISOCountries
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* uloc_getISOCountries_48( ) )! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:00'!
primGetISOLanguages
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* uloc_getISOLanguages_48( ) )! !

NBExternalStructure variableByteSubclass: #ICUErrorCodeNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUErrorCodeNB class methodsFor: 'fields description' stamp: 'jvds 2/12/2012 21:53'!
fieldsDesc
	^#(
		ulong status;	" # of last request processed by server "
	)! !

!ICUErrorCodeNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:38'!
check

	self status > 0
		ifTrue: [ self error: 'ICU Error: ', self status printString ]! !
